
/******************************************************************************
* MODULE     : extern.hh
* DESCRIPTION: for creating Mathemagix extensions
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __EXTERN_HH
#define __EXTERN_HH
#include <symbol.hh>
#include <symbols.hh>
namespace mmx {

typedef generic (*mmx_function) (generic);
generic template_type (generic v1, generic body);
generic template_type (generic v1, generic v2, generic body);
generic function_type (generic r);
generic function_type (generic x1, generic r);
generic function_type (generic x1, generic x2, generic r);
generic function_type (generic x1, generic x2, generic x3, generic r);
generic tuple_function_type (generic x, generic r);

void declare (symbol var_name, generic val, generic type);
void declare (symbol var_name, mmx_function fn, generic type);

void initialize_master ();
list get_extern_bindings ();

}
#endif // __EXTERN_HH
