
/******************************************************************************
* MODULE     : lib_print_alias.cc
* DESCRIPTION: Printing aliases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <printer.hh>
#include <function.hh>
#include <scheme.hh>
namespace mmx {

void
evaluator_rep::lib_print_alias_1 () {
  CHECK_SYNC (MMX_PRINT_ALIAS);
  // Input: (print_alias_1, arg, cont, ...)
  list    ret= cdr (as_list (car (rem)));
  printer out= as_printer (car (ret));
  generic val= cadr (ret);
  generic tp = car (trace)[1][2];
  generic x  = list (MMX_TRANSTYPE, value (val, tp), value (tp[1], ID_CLASS));
  cur= list (MMX_LESSLESS_STR, value (out, ID_OSTREAM), x);
  rem= cdr (rem);
  // Output: (print_instr, cont, ...)
  trace= cdr (trace);
}

} // namespace mmx
